program TIM_BMP;

{$APPTYPE CONSOLE}

uses
  Windows;

type
 TBGR = record
  B, G, R: Byte;
 end;

 PBGR  = ^PaBGR;
 PaBGR = array [0..1] of TBGR;


 P16  = ^Pa16;
 Pa16 = array [0..1] of WORD;

function ExtractFileName(FileName: string): string;
var
 i: integer;
begin
Result:='';
for i:=Length(FileName) downto 1 do
 if FileName[i]='\' then
  break
 else
  Result:=FileName[i]+Result;
end;

function ExtractFileName2(FileName: string): string;
var
 i: integer;
begin
Result:='';
for i:=Length(FileName) downto 1 do
 if FileName[i]='.' then
  begin
  Result:=Copy(FileName, 1, i-1);
  break;
  end;
end;

function ExtractFileDir(FileName: string): string;
var
 i: integer;
begin
for i:=Length(FileName) downto 1 do
 if FileName[i]='\' then break;
Result:=Copy(FileName, 1, i-1);
end;


var
 i, j: integer;
 w: WORD;
 F: File of Byte;
 bfh: TBitmapFileHeader;
 bmi: TBitmapInfoHeader;
 Str: string;
 BGR: PBGR;
 B16: P16;
 x, y: integer;
label
 ex;
begin
if ParamStr(1) = '' then
 begin
 writeln('Drop *.tim file on TIM_BMP.exe');
 goto ex;
 end;

FileMode:=64;
bfh.bfType:=$4D42;
bfh.bfOffBits:=54;
bmi.biSize:=40;
bmi.biBitCount:=24;
bmi.biPlanes:=1;

Str := ExtractFileName(ParamStr(1));
Write('Converting file: "'+Str+'"');
Str := ExtractFileName2(Str);
Writeln(' to "'+Str+'.bmp"');


FileMode:=64;
// tim 
AssignFile(F, ParamStr(1));
Reset(F);
Seek(F, 16);

BlockRead(F, w, 2);
bmi.biWidth:=w;
BlockRead(F, w, 2);
bmi.biHeight:=w;
bfh.bfSize:=bmi.biWidth*bmi.biHeight*3;


GetMem(B16, bmi.biWidth*bmi.biHeight*2);
GetMem(BGR, bmi.biWidth*bmi.biHeight*3);

BlockRead(F, B16[0], bmi.biWidth*bmi.biHeight*2);

CloseFile(F);

// 16  24  
j := 0;
for y := bmi.biHeight-1 downto 0 do
 begin
 i := y*bmi.biWidth;
 for x := bmi.biWidth-1 downto 0 do
  begin
  bgr[i].R := (B16[j] and $1F) shl 3;
  bgr[i].G := ((B16[j] shr 5) and $1F) shl 3;
  bgr[i].B := ((B16[j] shr 10) and $1F) shl 3;
  i := i + 1;
  j := j + 1;
  end;
 end;
FreeMem(b16);

AssignFile(F, ExtractFileDir(ParamStr(0))+'\'+Str+'.bmp');
Rewrite(F);
BlockWrite(F, bfh, SizeOf(bfh));
BlockWrite(F, bmi, SizeOf(bmi));
BlockWrite(F, bgr[0], bfh.bfSize);
CloseFile(F);
FreeMem(bgr);

ex:
 writeln;
 writeln('*********************************');
 writeln('* TIM to BMP created by XProger *');
 writeln('* 13.03.2004                    *');
 writeln('* site: www.XProger.narod.ru    *');
 writeln('* mail: XProger@list.ru         *');
 writeln('*********************************');
 readln;

end.

